<?php
namespace WC_Delivery_Time\Includes;

use WC_Delivery_Time\Includes\Helper\Model;

class WC_Delivery_Time_Conditions
{
	public static $instance = NULL;
	private $model;

	public static function get_instance()
	{
		NULL === self::$instance and self::$instance = new self;
		return self::$instance;
	}

	public function __construct() {
	    $this->model = Model::get_instance();
        add_filter('delivery_time_show_condition', [$this, 'check_category_ignore_condition'], 10, 1);
	}

	public function check_category_ignore_condition($show) {
        $cart_items = \WC()->cart->cart_contents;
        $has_none_cat_ignore = 0;
        foreach($cart_items as $item) {
            $product_id = $item['product_id'];
            $has_cat_ignore = 0;

            $product_cats = get_the_terms( $product_id, 'product_cat' );
            if(isset($product_cats) and !empty($product_cats)) {
                foreach ($product_cats as $key => $term) {
                    $term_id = $term->term_id;
                    $cat_ignore = get_term_meta($term_id, '_wcdt_cat_ignore', true);
                    if(isset($cat_ignore) and !empty($cat_ignore)) $has_cat_ignore++;

                }
            }
            if($has_cat_ignore === 0) $has_none_cat_ignore++;

        }
        if($has_none_cat_ignore > 0) return $show;
        return false;
    }
}